# PF

## Introductie

PF is de opvolger van Purefaçade.
Purefaçade maakte het eenvoudig mogelijk om data uit de Pure webservices beschikbaar te krijgen in de website,
in de vorm van HTML, RSS of vCards.
Purefaçade bood veel mogelijkheden.
Een aantal ervan kunnen worden overgenomen door de nieuwe Pure Portal.
Veel opties werden in de praktijk niet gebruikt.
Sommige opties waren nuttig toen Purefaçade gebouwd werd, maar zijn dat nu niet meer.
Caching, bijvoorbeeld, was in het begin nodig omdat Pure heel traag was.
Nu zit caching meer in de weg dan dat het nuttig is.
Pure heeft een eenvoudiger API gekregen, wat het parsen van de output van de webservices zeer sterk heeft vereenvoudigd.
PF gebruikt de nieuwe API van Pure webservices.
Verder wordt nu de APA-rendering van Pure zelf gebruikt, wat zeer veel programmatuur scheelt.
PF is daarom een systeem dat maar een paar dingen kan, en met veel minder opties.

```
+-----------+   +-----------+   +-----------+   +-----------+   +-----------+
| Applicatie|   | PF        |   | Pure      |   | Pure      |   | Bezoeker  | 
| of        <---+           <---+ web-      +---> Portal    +---> of        |
| browser   |   |           |   | services  |   |           |   | applicatie|
+-----------+   +-----------+   +-----^-----+   +-----------+   +-----------+
                                      |
                                      |
                                      |
                                +-----+-----+
                                | Pure      |
                                |           |
                                |           |
                                +-----------+
```

## Features

- Series, zoals CentER Discussion Paper-series, voor een jaar, gesorteerd op afnemend volume als RSS
- UUID van wetenschapper gegeven de mailnaam
- Data wetenschapper t.b.v. Experts & Expertise (Webwijs)

## Gebruik

Alle URLs zijn herschreven naar de omgeving waar PF draait.

### UUID van wetenschapper gegeven de mailnaam

#### Toelichting

Levert de UUID van een wetenschapper gegeven de mailnaam van de wetenschapper.

#### URL

- {BASEURL}/persons/person;mailname={MAILNAAM}/uuid

BASEURL hangt af van de omgeving.
Hier is het '${pf.base-url}'.
Of HTTP of HTTPS worden ondersteund, hangt af van de omgeving.
Mailnaam is case-insensitive.

#### Voorbeeld

- [${pf.base-url}/persons/person;mailname=T.A.Klimstra/uuid](${pf.base-url}/persons/person;mailname=T.A.Klimstra/uuid)

  - UUID van Theo Klimstra


### Series van een jaar compleet als RSS

#### Toelichting

Een RSS feed van publicaties van een zekere serie voor een jaar.
Publicaties gesorteerd op afnemend volume.

#### URL

- {BASEURL}/series?series=[NAAM-SERIES]&publication-year=[YYYY]&document-type={discussionpaper|thesisdoc}

BASEURL hangt af van de omgeving.
Hier is het '${pf.base-url}'.
Of HTTP of HTTPS worden ondersteund, hangt af van de omgeving.

Alle request parameters zijn verplicht.

Request parameter value voor 'series' moet letterlijk overeenstemmen met die vastgelegd in Pure, maar is wel case insensitive.

Request parameter value voor 'publication-year' is het jaar in vier cijfers.

Request parameter value voor 'document-type' is een van de opties zoals - door pipe-tekens gescheiden - bij URL beschreven.
Elke andere waarde is niet correct.
De programmatuur vertaalt deze verkorte namen naar de lange URI die Pure intern aanhoudt voor document type.

Dit verzoek leidt in de regel tot meerdere verzoeken aan Pure, waarbij veel meer wordt opgehaald dan nodig is.
Achteraf wordt er dan gefilterd.
Daardoor is dit verzoek relatief traag met antwoorden.
Indien mogelijk, dan de frequentie van opvragen beperken; bijvoorbeeld niet elke 5 minuten hernieuwd opvragen als een pagina open blijft staan.

Let op dat je heel precies alle request-parameters benoemt.
Een typo in bijvoorbeeld 'publication-year' maakt dat **alle** publicaties worden opgehaald.
Dat duurt vreselijk lang en kan service doen hangen.

#### Voorbeelden

- [${pf.base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper](${pf.base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper)

  - CentER Discussion Paper series van 2014
  
- [${pf.base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc](${pf.base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc)

  - CentER Dissertation Series van 2016

- [${pf.base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc](${pf.base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc)

  - TiCC Ph.D. Series van 2017


### Experts and Expertise-data wetenschapper

#### Toelichting

Levert voor een wetenschapper de XML op met alle relevante data uit Pure.
Kan als zodanig worden opgenomen in de XML voor een persoon voor Webijs/Experts and Expertise.

#### URLs

- {BASEURL}/persons/person;id={ID}/ee-data
- {BASEURL}/persons/person;uuid={UUID}/ee-data
- {BASEURL}/persons/person;mailname={MAILNAAM}/ee-data

BASEURL hangt af van de omgeving.
Hier is het '${pf.base-url}'.
Of HTTP of HTTPS worden ondersteund, hangt af van de omgeving.

Gebruik id (ANR) of mailnaam (email-adres tot de apenstaart) of UUID voor persoon.
De mailnaam is het deel voor de apenstaart in het email-adres.
Mailnaam is case-insensitive.
UUID kan per omgeving (Test, Productie) verschillen.

#### Voorbeelden

- [${pf.base-url}/persons/person;uuid=4c59b7b0-51af-4fbe-a8c1-4db53338511d/ee-data](${pf.base-url}/persons/person;uuid=4c59b7b0-51af-4fbe-a8c1-4db53338511d/ee-data)

  - Voorbeeld van wetenschapper die bij release van deze versie van PF geen voorkeurspublicaties heeft
  - Gebruik van UUID om persoon aan te duiden

- [${pf.base-url}/persons/person;mailname-j.j.sijtsema/ee-data](${pf.base-url}/persons/person;mailname=j.j.sijtsema/ee-data)

  - Voorbeeld van wetenschapper die bij release van deze versie van PF voorkeurspublicaties heeft
  - Gebruik van mailnaam om persoon aan te duiden

## Verder

### Release notes

Deze vind je [hier](release-notes).

### Roadmap

Deze vind je [hier](roadmap).
